Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::Drawable Class Reference

Pure virtual base class for drawable geometry. More...

Inheritance diagram for osg::Drawable:

[legend]
List of all members.

## Public Types
typedef std::vector< Node * > | ParentList
| A vector of osg::Node pointers which is used to store the parent(s) of drawable.
typedef unsigned int | AttributeType
enum | AttributeTypes { VERTICES = 0, WEIGHTS = 1, NORMALS = 2, COLORS = 3, SECONDARY_COLORS = 4, FOG_COORDS = 5, ATTRIBUTE_6 = 6, ATTRIBUTE_7 = 7, TEXTURE_COORDS = 8, TEXTURE_COORDS_0 = TEXTURE_COORDS, TEXTURE_COORDS_1 = TEXTURE_COORDS_0+1, TEXTURE_COORDS_2 = TEXTURE_COORDS_0+2, TEXTURE_COORDS_3 = TEXTURE_COORDS_0+3, TEXTURE_COORDS_4 = TEXTURE_COORDS_0+4, TEXTURE_COORDS_5 = TEXTURE_COORDS_0+5, TEXTURE_COORDS_6 = TEXTURE_COORDS_0+6, TEXTURE_COORDS_7 = TEXTURE_COORDS_0+7 }
## Public Member Functions
| Drawable ()
| Drawable (const Drawable &drawable, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor using CopyOp to manage deep vs shallow copy.
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
| return the name of the object's library.
virtual const char * | className () const
| return the name of the object's class type.
virtual Geometry * | asGeometry ()
| Convert 'this' into a Geometry pointer if Drawable is a Geometry, otherwise return 0.
virtual const Geometry * | asGeometry () const
| Convert 'const this' into a const Geometry pointer if Drawable is a Geometry, otherwise return 0.
const ParentList & | getParents () const
| Get the parent list of drawable.
ParentList | getParents ()
| Get the a copy of parent list of node.
Node * | getParent (unsigned int i)
| Get a single parent of Drawable.
const Node * | getParent (unsigned int i) const
| Get a single const parent of Drawable.
unsigned int | getNumParents () const
| Get the number of parents of node.
void | setStateSet (StateSet *stateset)
| Set the StateSet attached to the Drawable.
StateSet * | getStateSet ()
| Get the attached StateSet.
const StateSet * | getStateSet () const
| Get the attached const StateSet.
StateSet * | getOrCreateStateSet ()
| Get the attached const StateSet, if one is not already attached create one, attach it to the drawable and return a pointer to it.
void | setInitialBound (const osg::BoundingBox &bbox)
| Set the intial bounding volume to use when computing the overall bounding volume.
const BoundingBox & | getInitialBound () const
| Set the intial bounding volume to use when computing the overall bounding volume.
void | dirtyBound ()
| Dirty the bounding box, forcing a computeBound() on the next call to getBound().
const BoundingBox & | getBound () const
| get bounding box of geoset.
virtual BoundingBox | computeBound () const
| Compute the bounding box around Drawables's geometry.
void | setComputeBoundingBoxCallback (ComputeBoundingBoxCallback *callback)
| Set the compute bound callback to override the default computeBound.
ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback ()
| Get the compute bound callback.
const ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback () const
| Get the const compute bound callback.
void | setShape (Shape *shape)
| Set the Shape of the `Drawable`.
Shape * | getShape ()
| Get the Shape of the Drawable.
const Shape * | getShape () const
| Get the const Shape of the const Drawable.
void | setSupportsDisplayList (bool flag)
| Set the drawable so that it can or cannot be used in conjunction with OpenGL display lists.
bool | getSupportsDisplayList () const
| Get whether display lists are supported for this drawable instance.
void | setUseDisplayList (bool flag)
| When set to true, force the draw method to use OpenGL Display List for rendering.
bool | getUseDisplayList () const
| Return whether OpenGL display lists are being used for rendering.
GLuint & | getDisplayList (unsigned int contextID) const
| Return OpenGL display list for specified contextID.
void | setUseVertexBufferObjects (bool flag)
| When set to true, ignore the setUseDisplayList() settings, and hints to the drawImplementation method to use OpenGL vertex buffer objects for rendering.
bool | getUseVertexBufferObjects () const
| Return whether OpenGL vertex buffer objects should be used when supported by OpenGL driver.
void | dirtyDisplayList ()
| Force a recompile on next draw() of any OpenGL display list associated with this geoset.
virtual unsigned int | getGLObjectSizeHint () const
| Return the estimated size of GLObjects (display lists/vertex buffer objects) that are associated with this drawable.
void | draw (State &state) const
| Draw OpenGL primitives.
virtual void | compileGLObjects (State &state) const
| Immediately compile this `Drawable` into an OpenGL Display List.
virtual void | releaseGLObjects (State *state=0) const
| If State is non-zero, this function releases OpenGL objects for the specified graphics context.
virtual void | setUpdateCallback (UpdateCallback *ac)
| Set the UpdateCallback which allows users to attach customize the updating of an object during the update traversal.
UpdateCallback * | getUpdateCallback ()
| Get the non const UpdateCallback.
const UpdateCallback * | getUpdateCallback () const
| Get the const UpdateCallback.
bool | requiresUpdateTraversal () const
| Return whether this Drawable has update callbacks associated with it, and therefore must be traversed.
virtual void | setEventCallback (EventCallback *ac)
| Set the EventCallback which allows users to attach customize the updating of an object during the Event traversal.
EventCallback * | getEventCallback ()
| Get the non const EventCallback.
const EventCallback * | getEventCallback () const
| Get the const EventCallback.
bool | requiresEventTraversal () const
| Return whether this Drawable has event callbacks associated with it, and therefore must be traversed.
virtual void | setCullCallback (CullCallback *cc)
| Set the CullCallback which allows users to customize the culling of Drawable during the cull traversal.
CullCallback * | getCullCallback ()
| Get the non const CullCallback.
const CullCallback * | getCullCallback () const
| Get the const CullCallback.
virtual void | setDrawCallback (DrawCallback *dc)
| Set the DrawCallback which allows users to attach customize the drawing of existing Drawable object.
DrawCallback * | getDrawCallback ()
| Get the non const DrawCallback.
const DrawCallback * | getDrawCallback () const
| Get the const DrawCallback.
virtual void | drawImplementation (State &state) const=0
| drawImplementation(State&) is a pure virtaul method for the actual implementation of OpenGL drawing calls, such as vertex arrays and primitives, that must be implemented in concrete subclasses of the Drawable base class, examples include osg::Geometry and osg::ShapeDrawable.
virtual bool | supports (const AttributeFunctor &) const
| Return true if the Drawable subclass supports accept(AttributeFunctor&).
virtual void | accept (AttributeFunctor &)
| accept an AttributeFunctor and call its methods to tell it about the internal attributes that this Drawable has.
virtual bool | supports (const ConstAttributeFunctor &) const
| Return true if the Drawable subclass supports accept(ConstAttributeFunctor&).
virtual void | accept (ConstAttributeFunctor &) const
| Accept an AttributeFunctor and call its methods to tell it about the internal attributes that this Drawable has.
virtual bool | supports (const PrimitiveFunctor &) const
| Return true if the Drawable subclass supports accept(PrimitiveFunctor&).
virtual void | accept (PrimitiveFunctor &) const
| Accept a PrimitiveFunctor and call its methods to tell it about the internal primitives that this Drawable has.
virtual bool | supports (const PrimitiveIndexFunctor &) const
| Return true if the Drawable subclass supports accept(PrimitiveIndexFunctor&).
virtual void | accept (PrimitiveIndexFunctor &) const
| Accept a PrimitiveIndexFunctor and call its methods to tell it about the internal primitives that this Drawable has.
## Static Public Member Functions
GLuint | generateDisplayList (unsigned int contextID, unsigned int sizeHint=0)
| Return a OpenGL display list handle a newly generated or reused from display list cache.
void | setMinimumNumberOfDisplayListsToRetainInCache (unsigned int minimum)
| Set the minimum number of display lists to retain in the deleted display list cache.
unsigned int | getMinimumNumberOfDisplayListsToRetainInCache ()
| Get the minimum number of display lists to retain in the deleted display list cache.
void | deleteDisplayList (unsigned int contextID, GLuint globj, unsigned int sizeHint=0)
| Use deleteDisplayList instead of glDeleteList to allow OpenGL display list to be cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.
void | flushAllDeletedDisplayLists (unsigned int contextID)
| Flush all the cached display list which need to be deleted in the OpenGL context related to contextID.
void | flushDeletedDisplayLists (unsigned int contextID, double &availableTime)
| Flush the cached display list which need to be deleted in the OpenGL context related to contextID.
void | deleteVertexBufferObject (unsigned int contextID, GLuint globj)
| Use deleteVertexBufferObject instead of glDeleteBuffers to allow OpenGL buffer objects to be cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.
void | flushDeletedVertexBufferObjects (unsigned int contextID, double currentTime, double &availableTime)
| Flush all the cached vertex buffer objects which need to be deleted in the OpenGL context related to contextID.
Extensions * | getExtensions (unsigned int contextID, bool createIfNotInitalized)
| Function to call to get the extension of a specified context.
void | setExtensions (unsigned int contextID, Extensions *extensions)
| setExtensions allows users to override the extensions across graphics contexts.
## Static Public Attributes
unsigned int | s_numberDrawablesReusedLastInLastFrame
unsigned int | s_numberNewDrawablesInLastFrame
unsigned int | s_numberDeletedDrawablesInLastFrame
## Protected Types
typedef osg::buffered_value< GLuint > | GLObjectList
## Protected Member Functions
Drawable & | operator= (const Drawable &)
virtual | ~Drawable ()
void | setBound (const BoundingBox &bb) const
| set the bounding box .
void | addParent (osg::Node *node)
void | removeParent (osg::Node *node)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setNumChildrenRequiringEventTraversal (unsigned int num)
unsigned int | getNumChildrenRequiringEventTraversal () const
## Protected Attributes
ParentList | _parents
ref_ptr< StateSet > | _stateset
BoundingBox | _initialBound
ref_ptr< ComputeBoundingBoxCallback > | _computeBoundCallback
BoundingBox | _boundingBox
bool | _boundingBoxComputed
ref_ptr< Shape > | _shape
bool | _supportsDisplayList
bool | _useDisplayList
bool | _supportsVertexBufferObjects
bool | _useVertexBufferObjects
GLObjectList | _globjList
GLObjectList | _vboList
ref_ptr< UpdateCallback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< EventCallback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< CullCallback > | _cullCallback
ref_ptr< DrawCallback > | _drawCallback

## Detailed Description

Pure virtual base class for drawable geometry.

In OSG, everything that can be rendered is implemented as a class derived from `Drawable`. The `Drawable` class contains no drawing primitives, since these are provided by subclasses such as `osg::Geometry`.

Notice that a `Drawable` is not a `Node`, and therefore it cannot be directly added to a scene graph. Instead, `Drawable`s are attached to `Geode`s, which are scene graph nodes.

The OpenGL state that must be used when rendering a `Drawable` is represented by a `StateSet`. Since a `Drawable` has a reference (`osg::ref_ptr`) to a `StateSet`, `StateSet`s can be shared between different `Drawable`s. In fact, sharing `StateSet`s is a good way to improve performance, since this allows OSG to reduce the number of expensive changes in the OpenGL state.

Finally, `Drawable`s can also be shared between different `Geode`s, so that the same geometry (loaded to memory just once) can be used in different parts of the scene graph.

## Member Typedef Documentation

typedef unsigned int osg::Drawable::AttributeType

typedef osg::buffered_value<GLuint> osg::Drawable::GLObjectList`[protected]`

typedef std::vector<Node*> osg::Drawable::ParentList

| A vector of osg::Node pointers which is used to store the parent(s) of drawable.

## Member Enumeration Documentation

enum osg::Drawable::AttributeTypes

  | Enumeration values:
  VERTICES |
  WEIGHTS |
  NORMALS |
  COLORS |
  SECONDARY_COLORS |
  FOG_COORDS |
  ATTRIBUTE_6 |
  ATTRIBUTE_7 |
  TEXTURE_COORDS |
  TEXTURE_COORDS_0 |
  TEXTURE_COORDS_1 |
  TEXTURE_COORDS_2 |
  TEXTURE_COORDS_3 |
  TEXTURE_COORDS_4 |
  TEXTURE_COORDS_5 |
  TEXTURE_COORDS_6 |
  TEXTURE_COORDS_7 |

## Constructor & Destructor Documentation

osg::Drawable::Drawable | ( |  | ) |

osg::Drawable::Drawable | ( | const Drawable & | drawable,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY
| ) |

| Copy constructor using CopyOp to manage deep vs shallow copy.

virtual osg::Drawable::~Drawable | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

virtual void osg::Drawable::accept | ( | PrimitiveIndexFunctor & |  | ) | const`[inline, virtual]`

| Accept a PrimitiveIndexFunctor and call its methods to tell it about the internal primitives that this Drawable has. return true if functor handled by drawable, return false on failure of drawable to generate functor calls. Note, PrimtiveIndexFunctor only provide const access of the primitives, as primitives may be procedurally generated so one cannot modify it. Reimplemented in osg::Geometry.

virtual void osg::Drawable::accept | ( | PrimitiveFunctor & |  | ) | const`[inline, virtual]`

| Accept a PrimitiveFunctor and call its methods to tell it about the internal primitives that this Drawable has. return true if functor handled by drawable, return false on failure of drawable to generate functor calls. Note, PrimtiveFunctor only provides const access of the primitives, as primitives may be procedurally generated so one cannot modify it. Reimplemented in osg::Geometry, osg::ShapeDrawable, osgSim::ImpostorSprite, and osgText::Text.

virtual void osg::Drawable::accept | ( | ConstAttributeFunctor & |  | ) | const`[inline, virtual]`

| Accept an AttributeFunctor and call its methods to tell it about the internal attributes that this Drawable has. return true if functor handled by drawable, return false on failure of drawable to generate functor calls. Reimplemented in osg::Geometry, osg::ShapeDrawable, and osgSim::ImpostorSprite.

virtual void osg::Drawable::accept | ( | AttributeFunctor & |  | ) | `[inline, virtual]`

| accept an AttributeFunctor and call its methods to tell it about the internal attributes that this Drawable has. return true if functor handled by drawable, return false on failure of drawable to generate functor calls. Reimplemented in osg::Geometry, and osgSim::ImpostorSprite.

void osg::Drawable::addParent | ( | osg::Node * | node | ) | `[protected]`

virtual const Geometry* osg::Drawable::asGeometry | ( |  | ) | const`[inline, virtual]`

| Convert 'const this' into a const Geometry pointer if Drawable is a Geometry, otherwise return 0. Equivalent to dynamic_cast<const Geometry*>(this). Reimplemented in osg::Geometry.

virtual Geometry* osg::Drawable::asGeometry | ( |  | ) | `[inline, virtual]`

| Convert 'this' into a Geometry pointer if Drawable is a Geometry, otherwise return 0. Equivalent to dynamic_cast<Geometry*>(this). Reimplemented in osg::Geometry.

virtual const char* osg::Drawable::className | ( |  | ) | const`[inline, virtual]`

| return the name of the object's class type. Must be defined by derived classes. Implements osg::Object. Reimplemented in osg::DrawPixels, osg::Geometry, osg::ShapeDrawable, osgSim::ImpostorSprite, and osgText::Text.

virtual void osg::Drawable::compileGLObjects | ( | State & | state | ) | const`[virtual]`

| Immediately compile this `Drawable` into an OpenGL Display List. Note: Operation is ignored if `_useDisplayList` is `false`. This member function is not intended to be overridden in subclasses (notice that it is not even `virtual`).

virtual BoundingBox osg::Drawable::computeBound | ( |  | ) | const`[virtual]`

| Compute the bounding box around Drawables's geometry. Reimplemented in osg::DrawPixels, osg::ShapeDrawable, osgParticle::ParticleSystem, osgSim::ImpostorSprite, and osgText::Text.

void osg::Drawable::deleteDisplayList | ( | unsigned int | contextID,
|  | GLuint | globj,
|  | unsigned int | sizeHint = 0
| ) | `[static]`

| Use deleteDisplayList instead of glDeleteList to allow OpenGL display list to be cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.

void osg::Drawable::deleteVertexBufferObject | ( | unsigned int | contextID,
|  | GLuint | globj
| ) | `[static]`

| Use deleteVertexBufferObject instead of glDeleteBuffers to allow OpenGL buffer objects to be cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.

void osg::Drawable::dirtyBound | ( |  | ) |

| Dirty the bounding box, forcing a computeBound() on the next call to getBound(). Should be called in the internal geometry of the Drawable is modified.

void osg::Drawable::dirtyDisplayList | ( |  | ) |

| Force a recompile on next draw() of any OpenGL display list associated with this geoset.

void osg::Drawable::draw | ( | State & | state | ) | const`[inline]`

| Draw OpenGL primitives. If the `Drawable` has `_useDisplayList` set to `true`, then use an OpenGL display list, automatically compiling one if required. Otherwise, call `drawImplementation()`. Note: This method should not be overridden in subclasses, as it manages the optional display list (notice this is not even `virtual`). Subclasses should override `drawImplementation()` instead.

virtual void osg::Drawable::drawImplementation | ( | State & | state | ) | const`[pure virtual]`

  | drawImplementation(State&) is a pure virtaul method for the actual implementation of OpenGL drawing calls, such as vertex arrays and primitives, that must be implemented in concrete subclasses of the Drawable base class, examples include osg::Geometry and osg::ShapeDrawable. drawImplementation(State&) is called from the draw(State&) method, with the draw method handling management of OpenGL display lists, and drawImplementation(State&) handling the actuall drawing itself. Parameters:
  state | The osg::State object that encapulates the current OpenGL state for the current graphics context.
Implemented in osg::DrawPixels, osg::Geometry, osg::ShapeDrawable, osgParticle::ConnectedParticleSystem, osgParticle::ParticleSystem, osgSim::ImpostorSprite, and osgText::Text.

void osg::Drawable::flushAllDeletedDisplayLists | ( | unsigned int | contextID | ) | `[static]`

| Flush all the cached display list which need to be deleted in the OpenGL context related to contextID.

void osg::Drawable::flushDeletedDisplayLists | ( | unsigned int | contextID,
|  | double & | availableTime
| ) | `[static]`

| Flush the cached display list which need to be deleted in the OpenGL context related to contextID.

void osg::Drawable::flushDeletedVertexBufferObjects | ( | unsigned int | contextID,
|  | double | currentTime,
|  | double & | availableTime
| ) | `[static]`

| Flush all the cached vertex buffer objects which need to be deleted in the OpenGL context related to contextID.

GLuint osg::Drawable::generateDisplayList | ( | unsigned int | contextID,
|  | unsigned int | sizeHint = 0
| ) | `[static]`

| Return a OpenGL display list handle a newly generated or reused from display list cache.

const BoundingBox& osg::Drawable::getBound | ( |  | ) | const`[inline]`

| get bounding box of geoset. Note, now made virtual to make it possible to implement user-drawn objects albeit somewhat crudely, to be improved later.

const ComputeBoundingBoxCallback* osg::Drawable::getComputeBoundingBoxCallback | ( |  | ) | const`[inline]`

| Get the const compute bound callback.

ComputeBoundingBoxCallback* osg::Drawable::getComputeBoundingBoxCallback | ( |  | ) | `[inline]`

| Get the compute bound callback.

const CullCallback* osg::Drawable::getCullCallback | ( |  | ) | const`[inline]`

| Get the const CullCallback.

CullCallback* osg::Drawable::getCullCallback | ( |  | ) | `[inline]`

| Get the non const CullCallback.

GLuint& osg::Drawable::getDisplayList | ( | unsigned int | contextID | ) | const`[inline]`

| Return OpenGL display list for specified contextID.

const DrawCallback* osg::Drawable::getDrawCallback | ( |  | ) | const`[inline]`

| Get the const DrawCallback.

DrawCallback* osg::Drawable::getDrawCallback | ( |  | ) | `[inline]`

| Get the non const DrawCallback.

const EventCallback* osg::Drawable::getEventCallback | ( |  | ) | const`[inline]`

| Get the const EventCallback.

EventCallback* osg::Drawable::getEventCallback | ( |  | ) | `[inline]`

| Get the non const EventCallback.

Extensions* osg::Drawable::getExtensions | ( | unsigned int | contextID,
|  | bool | createIfNotInitalized
| ) | `[static]`

| Function to call to get the extension of a specified context. If the Exentsion object for that context has not yet been created and the 'createIfNotInitalized' flag been set to false then returns NULL. If 'createIfNotInitalized' is true then the Extensions object is automatically created. However, in this case the extension object is only created with the graphics context associated with ContextID..

virtual unsigned int osg::Drawable::getGLObjectSizeHint | ( |  | ) | const`[inline, virtual]`

| Return the estimated size of GLObjects (display lists/vertex buffer objects) that are associated with this drawable. This size is used a hint for reuse of deleteed display lists/vertex buffer objects. Reimplemented in osg::Geometry.

const BoundingBox& osg::Drawable::getInitialBound | ( |  | ) | const`[inline]`

| Set the intial bounding volume to use when computing the overall bounding volume.

unsigned int osg::Drawable::getMinimumNumberOfDisplayListsToRetainInCache | ( |  | ) | `[static]`

| Get the minimum number of display lists to retain in the deleted display list cache.

unsigned int osg::Drawable::getNumChildrenRequiringEventTraversal | ( |  | ) | const`[inline, protected]`

unsigned int osg::Drawable::getNumChildrenRequiringUpdateTraversal | ( |  | ) | const`[inline, protected]`

unsigned int osg::Drawable::getNumParents | ( |  | ) | const`[inline]`

| Get the number of parents of node. Returns: the number of parents of this node.

StateSet* osg::Drawable::getOrCreateStateSet | ( |  | ) |

| Get the attached const StateSet, if one is not already attached create one, attach it to the drawable and return a pointer to it.

const Node* osg::Drawable::getParent | ( | unsigned int | i | ) | const`[inline]`

  | Get a single const parent of Drawable. Parameters:
  i | index of the parent to get.
Returns: the parent i.

Node* osg::Drawable::getParent | ( | unsigned int | i | ) | `[inline]`

  | Get a single parent of Drawable. Parameters:
  i | index of the parent to get.
Returns: the parent i.

ParentList osg::Drawable::getParents | ( |  | ) | `[inline]`

| Get the a copy of parent list of node. A copy is returned to prevent modification of the parent list.

const ParentList& osg::Drawable::getParents | ( |  | ) | const`[inline]`

| Get the parent list of drawable.

const Shape* osg::Drawable::getShape | ( |  | ) | const`[inline]`

| Get the const Shape of the const Drawable.

Shape* osg::Drawable::getShape | ( |  | ) | `[inline]`

| Get the Shape of the Drawable.

const StateSet* osg::Drawable::getStateSet | ( |  | ) | const`[inline]`

| Get the attached const StateSet.

StateSet* osg::Drawable::getStateSet | ( |  | ) | `[inline]`

| Get the attached StateSet.

bool osg::Drawable::getSupportsDisplayList | ( |  | ) | const`[inline]`

| Get whether display lists are supported for this drawable instance.

const UpdateCallback* osg::Drawable::getUpdateCallback | ( |  | ) | const`[inline]`

| Get the const UpdateCallback.

UpdateCallback* osg::Drawable::getUpdateCallback | ( |  | ) | `[inline]`

| Get the non const UpdateCallback.

bool osg::Drawable::getUseDisplayList | ( |  | ) | const`[inline]`

| Return whether OpenGL display lists are being used for rendering.

bool osg::Drawable::getUseVertexBufferObjects | ( |  | ) | const`[inline]`

| Return whether OpenGL vertex buffer objects should be used when supported by OpenGL driver.

virtual bool osg::Drawable::isSameKindAs | ( | const Object * | obj | ) | const`[inline, virtual]`

| Reimplemented from osg::Object. Reimplemented in osg::DrawPixels, osg::Geometry, and osg::ShapeDrawable.

virtual const char* osg::Drawable::libraryName | ( |  | ) | const`[inline, virtual]`

| return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name. Implements osg::Object. Reimplemented in osg::DrawPixels, osg::Geometry, osg::ShapeDrawable, osgSim::ImpostorSprite, and osgText::Text.

Drawable& osg::Drawable::operator= | ( | const Drawable & |  | ) | `[inline, protected]`

virtual void osg::Drawable::releaseGLObjects | ( | State * | state = 0 | ) | const`[virtual]`

| If State is non-zero, this function releases OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objexts for all graphics contexts. Reimplemented from osg::Object. Reimplemented in osgText::Text.

void osg::Drawable::removeParent | ( | osg::Node * | node | ) | `[protected]`

bool osg::Drawable::requiresEventTraversal | ( |  | ) | const`[inline]`

| Return whether this Drawable has event callbacks associated with it, and therefore must be traversed.

bool osg::Drawable::requiresUpdateTraversal | ( |  | ) | const`[inline]`

| Return whether this Drawable has update callbacks associated with it, and therefore must be traversed.

void osg::Drawable::setBound | ( | const BoundingBox & | bb | ) | const`[protected]`

| set the bounding box .

void osg::Drawable::setComputeBoundingBoxCallback | ( | ComputeBoundingBoxCallback * | callback | ) | `[inline]`

| Set the compute bound callback to override the default computeBound.

virtual void osg::Drawable::setCullCallback | ( | CullCallback * | cc | ) | `[inline, virtual]`

| Set the CullCallback which allows users to customize the culling of Drawable during the cull traversal.

virtual void osg::Drawable::setDrawCallback | ( | DrawCallback * | dc | ) | `[inline, virtual]`

| Set the DrawCallback which allows users to attach customize the drawing of existing Drawable object.

virtual void osg::Drawable::setEventCallback | ( | EventCallback * | ac | ) | `[virtual]`

| Set the EventCallback which allows users to attach customize the updating of an object during the Event traversal.

void osg::Drawable::setExtensions | ( | unsigned int | contextID,
|  | Extensions * | extensions
| ) | `[static]`

| setExtensions allows users to override the extensions across graphics contexts. typically used when you have different extensions supported across graphics pipes but need to ensure that they all use the same low common denominator extensions.

void osg::Drawable::setInitialBound | ( | const osg::BoundingBox & | bbox | ) | `[inline]`

| Set the intial bounding volume to use when computing the overall bounding volume.

void osg::Drawable::setMinimumNumberOfDisplayListsToRetainInCache | ( | unsigned int | minimum | ) | `[static]`

| Set the minimum number of display lists to retain in the deleted display list cache.

void osg::Drawable::setNumChildrenRequiringEventTraversal | ( | unsigned int | num | ) | `[protected]`

void osg::Drawable::setNumChildrenRequiringUpdateTraversal | ( | unsigned int | num | ) | `[protected]`

void osg::Drawable::setShape | ( | Shape * | shape | ) | `[inline]`

| Set the Shape of the `Drawable`. The shape can be used to speed up collision detection or as a guide for procedural geometry generation. See also: osg::Shape.

void osg::Drawable::setStateSet | ( | StateSet * | stateset | ) |

| Set the StateSet attached to the Drawable. Previously attached StateSet are automatically unreferenced on assignment of a new drawstate.

void osg::Drawable::setSupportsDisplayList | ( | bool | flag | ) |

| Set the drawable so that it can or cannot be used in conjunction with OpenGL display lists. When set to true, calls to Drawable::setUseDisplayList, whereas when set to false, no display lists can be created and calls to setUseDisplayList are ignored, and a warning is produced. The latter is typically used to guard against the switching on of display lists on objects with dynamic internal data such as continuous Level of Detail algorithms.

virtual void osg::Drawable::setUpdateCallback | ( | UpdateCallback * | ac | ) | `[virtual]`

| Set the UpdateCallback which allows users to attach customize the updating of an object during the update traversal.

void osg::Drawable::setUseDisplayList | ( | bool | flag | ) |

| When set to true, force the draw method to use OpenGL Display List for rendering. If false, rendering directly. If the display list has not been compiled already, the next call to draw will automatically create the display list.

void osg::Drawable::setUseVertexBufferObjects | ( | bool | flag | ) |

| When set to true, ignore the setUseDisplayList() settings, and hints to the drawImplementation method to use OpenGL vertex buffer objects for rendering.

virtual bool osg::Drawable::supports | ( | const PrimitiveIndexFunctor & |  | ) | const`[inline, virtual]`

| Return true if the Drawable subclass supports accept(PrimitiveIndexFunctor&). Reimplemented in osg::Geometry.

virtual bool osg::Drawable::supports | ( | const PrimitiveFunctor & |  | ) | const`[inline, virtual]`

| Return true if the Drawable subclass supports accept(PrimitiveFunctor&). Reimplemented in osg::Geometry, and osg::ShapeDrawable.

virtual bool osg::Drawable::supports | ( | const ConstAttributeFunctor & |  | ) | const`[inline, virtual]`

| Return true if the Drawable subclass supports accept(ConstAttributeFunctor&). Reimplemented in osg::Geometry, osg::ShapeDrawable, and osgSim::ImpostorSprite.

virtual bool osg::Drawable::supports | ( | const AttributeFunctor & |  | ) | const`[inline, virtual]`

| Return true if the Drawable subclass supports accept(AttributeFunctor&). Reimplemented in osg::Geometry, osg::ShapeDrawable, and osgSim::ImpostorSprite.

## Member Data Documentation

BoundingBox osg::Drawable::_boundingBox`[mutable, protected]`

bool osg::Drawable::_boundingBoxComputed`[mutable, protected]`

ref_ptr<ComputeBoundingBoxCallback> osg::Drawable::_computeBoundCallback`[protected]`

ref_ptr<CullCallback> osg::Drawable::_cullCallback`[protected]`

ref_ptr<DrawCallback> osg::Drawable::_drawCallback`[protected]`

ref_ptr<EventCallback> osg::Drawable::_eventCallback`[protected]`

GLObjectList osg::Drawable::_globjList`[mutable, protected]`

BoundingBox osg::Drawable::_initialBound`[protected]`

unsigned int osg::Drawable::_numChildrenRequiringEventTraversal`[protected]`

unsigned int osg::Drawable::_numChildrenRequiringUpdateTraversal`[protected]`

ParentList osg::Drawable::_parents`[protected]`

ref_ptr<Shape> osg::Drawable::_shape`[protected]`

ref_ptr<StateSet> osg::Drawable::_stateset`[protected]`

bool osg::Drawable::_supportsDisplayList`[protected]`

bool osg::Drawable::_supportsVertexBufferObjects`[protected]`

ref_ptr<UpdateCallback> osg::Drawable::_updateCallback`[protected]`

bool osg::Drawable::_useDisplayList`[protected]`

bool osg::Drawable::_useVertexBufferObjects`[protected]`

GLObjectList osg::Drawable::_vboList`[mutable, protected]`

unsigned int osg::Drawable::s_numberDeletedDrawablesInLastFrame`[static]`

unsigned int osg::Drawable::s_numberDrawablesReusedLastInLastFrame`[static]`

unsigned int osg::Drawable::s_numberNewDrawablesInLastFrame`[static]`

The documentation for this class was generated from the following file:

- Drawable